% Przyklad 3.3:
% m-plik: przyklad_3_3.m
%
% Cyfrowe przetwarzanie sygnalow. Podstawy, multimedia, transmisja. PWN, Warszawa, 2014.
% Rozdzial 3. Sygnaly losowe i szumy. 
% Autorzy rozdzialu: Przemyslaw Korohoda, Adam Borowicz, Krzysztof Duda.
%
% Wiecej na stronie internetowej: http://teledsp.kt.agh.edu.pl
%
% Opracowanie przykladu: kwiecien 2013 r./PK.

clc; clear; close all; 

K=2^10;
N=2^14;         % Patrz przyklad 3.1
F=(0:N-1)/N;    % przygotowanie osi unormowanej czestotliwosci;

wersja=1;       % wybor wersji danych (wybor procesu losowego x);
switch wersja,
    case 1,   mu=0;     sigma=4;    x=randn(1,N)*sigma+mu;   k=1:N/2+1;   a=1;
    case 2,   muR=0;    sigmaR=1;   muI=0;   sigmaI=1;
              x=randn(1,N)*sigmaR+muR + j*(randn(1,N)*sigmaI+muI); % proces zespolony!!! Widmo nie bedzie mialo charakterystycznych symetrii;
              k=1:N;  a=1;
end;

y=rand(1,N);    % realizacja procesu y;
c1=xcorr(y,x); c2=conv(y,conj(x(end:-1:1))); % wyznaczamy funkcje korelacji dwiema metodami;
disp('Roznica po wyznaczeniu funkcji korelacji dwiema metodami:');
err=max(abs(c1-c2)),                         % porownujemy wyniki;

X=fft(x);       % DFT ciagu x;

[P1,W1]=periodogram(x,hamming(N),K); F1=W1/(2*pi); % periodogram z (pojedynczym) oknem Hamminga;
[P2,W2]=pwelch(x,K);                 F2=W2/(2*pi); % periodogram wyznaczony metoda Welcha;

    figure(1);
            plot(F1,P1,'ro-'); grid on; hold on;  axis tight;
            plot(F2,P2,'b.-');
                xlabel('F');    ylabel('Widmowa gestosc mocy (PSD)');    legend('a) periodogram','b) pwelch');
                title('Dwa periodogramy - konfrontacja wynikow zastosowania dwoch funkcji');

% KONIEC PRZYKLADU 3.3.